#ifndef INTERPOLATOR_H_INCLUDED
#define INTERPOLATOR_H_INCLUDED

#include "types.h"

static const u32 INTERPOLATOR_ORDER = 42;
static const u32 INTERPOLATOR_FACTOR = 6;
static const u32 INTERPOLATOR_UP_SIZE = INTERPOLATOR_ORDER/INTERPOLATOR_FACTOR+1;

class INTERPOLATOR
{
	s16 buf_up[INTERPOLATOR_UP_SIZE];
	u32 buf_up_inx;
	s16 buf_down[INTERPOLATOR_ORDER+1];
	u32 buf_down_inx;
	u32 buf_down_cnt;

public:
	INTERPOLATOR();
	~INTERPOLATOR();
    
	void upsample(s16* buf_in, u32 size, s16* buf_out);
	void downsample(s16* buf_in, u32 size, s16* buf_out);
};

#endif
